VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTooltip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

' Windows API Functions
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal Hwnd As Long) As Long

' Windows API Constants
Private Const CW_USEDEFAULT = &H80000000
Private Const WM_USER = &H400
Private Const WM_SETFONT As Long = &H30
Private Const WM_GETFONT As Long = &H31

' Windows API Types
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

' Tooltip Window Constants
Private Const TTS_NOPREFIX = &H2
Private Const TTS_BALLOON = &H40
Private Const TTS_ALWAYSTIP = &H1

Private Const TTF_CENTERTIP = &H2
Private Const TTF_ABSOLUTE As Long = &H80
Private Const TTF_TRACK As Long = &H20
Private Const TTF_SUBCLASS = &H10
Private Const TTF_IDISHWND = &H1

Private Const TTM_TRACKPOSITION As Long = (WM_USER + 18)
Private Const TTM_TRACKACTIVATE As Long = (WM_USER + 17)
Private Const TTM_ADDTOOLA = (WM_USER + 4)
Private Const TTM_UPDATETIPTEXTA = (WM_USER + 12)
Private Const TTM_SETTIPBKCOLOR = (WM_USER + 19)
Private Const TTM_SETTIPTEXTCOLOR = (WM_USER + 20)
Private Const TTM_SETTITLE = (WM_USER + 32)
Private Const TTM_SETDELAYTIME = (WM_USER + 3)

Private Const TTDT_AUTOPOP = 2
Private Const TTDT_INITIAL = 3

Private Const TOOLTIPS_CLASSA = "tooltips_class32"

' Tooltip Window Types
Private Type TOOLINFO
    lSize As Long
    lFlags As Long
    Hwnd As Long
    lId As Long
    lpRect As RECT
    hInstance As Long
    lpStr As String
    lParam As Long
End Type

Public Enum ttIconType
    TTNoIcon = 0
    TTIconInfo = 1
    TTIconWarning = 2
    TTIconError = 3
End Enum

Public Enum ttStyleEnum
    TTStandard
    TTBalloon
End Enum

' local variables to hold property values
Private mvarBackColor As Long
Private mvarTitle As String
Private mvarForeColor As Long
Private mvarIcon As ttIconType
Private mvarCentered As Boolean
Private mvarStyle As ttStyleEnum
Private mvarTipText As String
Private mvarVisibleTime As Long
Private mvarDelayTime As Long
Private mvarTopLeftCorner As Long
Private mvarMaxTipWidth As Long
Private mvarIsShown As Boolean
Private m_lHwnd As Long     ' << hWnd of the tooltip

' private data
Private m_lParentHwnd As Long ' << hWnd of the window the tooltip attached to
Private ti As TOOLINFO

Public Property Let IsShown(ByVal vData As Boolean)
    mvarIsShown = vData
End Property

Public Property Get IsShown() As Boolean
    IsShown = mvarIsShown
End Property

Public Sub Show()
    SendMessage m_lHwnd, TTM_TRACKACTIVATE, 1, ti
    mvarIsShown = True
End Sub

Public Sub Hide()
    If mvarIsShown Then
        mvarIsShown = False
        SendMessage m_lHwnd, TTM_TRACKACTIVATE, 0, ti
    End If
End Sub

Public Property Get Hwnd() As Long
    ' read-only property assigned in "Create" method
    Hwnd = m_lHwnd
End Property

Public Property Let MaxTipWidth(ByVal vData As Long)
    mvarMaxTipWidth = vData
End Property

Public Property Get MaxTipWidth() As Long
    MaxTipWidth = mvarMaxTipWidth
End Property

Public Property Let TopLeftCorner(ByVal vData As Long)
    mvarTopLeftCorner = vData
    If m_lHwnd <> 0 Then
        SendMessageLong m_lHwnd, TTM_TRACKPOSITION, 0, mvarTopLeftCorner
    End If
End Property

Public Property Get TopLeftCorner() As Long
    TopLeftCorner = mvarTopLeftCorner
End Property

Public Property Let Style(ByVal vData As ttStyleEnum)
    mvarStyle = vData
End Property

Public Property Get Style() As ttStyleEnum
    Style = mvarStyle
End Property

Public Property Let Centered(ByVal vData As Boolean)
    mvarCentered = vData
End Property

Public Property Get Centered() As Boolean
    Centered = mvarCentered
End Property

Public Sub SetFontToWindow(ByVal winHwnd As Long)
    Dim hFont As Long
    Dim lRet As Long
    hFont = SendMessageLong(winHwnd, WM_GETFONT, 0, 0)
    lRet = SendMessageLong(m_lHwnd, WM_SETFONT, hFont, 1&)
End Sub

Public Function Create(ByVal ParentHwnd As Long, Optional ByVal IsTrackable As Boolean = True) As Boolean
    Dim lWinStyle As Long
    
    If m_lHwnd <> 0 Then DestroyWindow m_lHwnd
   
    m_lParentHwnd = ParentHwnd
   
    lWinStyle = TTS_ALWAYSTIP Or TTS_NOPREFIX
   
    ' create baloon style if desired
    If mvarStyle = TTBalloon Then lWinStyle = lWinStyle Or TTS_BALLOON
    
    m_lHwnd = CreateWindowEx(0&, _
        TOOLTIPS_CLASSA, _
        vbNullString, _
        lWinStyle, _
        CW_USEDEFAULT, _
        CW_USEDEFAULT, _
        CW_USEDEFAULT, _
        CW_USEDEFAULT, _
        0&, _
        0&, _
        App.hInstance, _
        0&)
               
    ' now set our tooltip info structure:
    With ti
        .lFlags = TTF_SUBCLASS Or TTF_IDISHWND
        If IsTrackable Then .lFlags = .lFlags Or TTF_ABSOLUTE Or TTF_TRACK
        If mvarCentered Then .lFlags = .lFlags Or TTF_CENTERTIP
        .Hwnd = 0  ' << otherwise we get big problems with Z-order of the tooltip window!
        .lId = m_lParentHwnd
        .hInstance = App.hInstance
        '.lpstr =
        '.lpRect =
        .lSize = Len(ti)
    End With
   
    ' add the tooltip structure
    SendMessage m_lHwnd, TTM_ADDTOOLA, 0&, ti
    
    ' if we want a title or we want an icon
    If mvarTitle <> vbNullString Or mvarIcon <> TTNoIcon Then
        SendMessage m_lHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    End If

    SendMessageLong m_lHwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, mvarVisibleTime
    SendMessageLong m_lHwnd, TTM_SETDELAYTIME, TTDT_INITIAL, mvarDelayTime
    
    Call SetFontToWindow(m_lParentHwnd)
    
End Function

Public Property Let Icon(ByVal vData As ttIconType)
    mvarIcon = vData
    If m_lHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then
        SendMessage m_lHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    End If
End Property

Public Property Get Icon() As ttIconType
    Icon = mvarIcon
End Property

Public Property Let ForeColor(ByVal vData As Long)
    mvarForeColor = vData
    If m_lHwnd <> 0 Then SendMessage m_lHwnd, TTM_SETTIPTEXTCOLOR, mvarForeColor, 0&
End Property

Public Property Get ForeColor() As Long
    ForeColor = mvarForeColor
End Property

Public Property Let Title(ByVal vData As String)
    mvarTitle = vData
    If m_lHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then
        SendMessage m_lHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    End If
End Property

Public Property Get Title() As String
    Title = ti.lpStr
End Property

Public Property Let BackColor(ByVal vData As Long)
    mvarBackColor = vData
    If m_lHwnd <> 0 Then SendMessage m_lHwnd, TTM_SETTIPBKCOLOR, mvarBackColor, 0&
End Property

Public Property Get BackColor() As Long
    BackColor = mvarBackColor
End Property

Public Property Let TipText(ByVal vData As String)
    mvarTipText = vData
    ti.lpStr = vData
    If m_lHwnd <> 0 Then SendMessage m_lHwnd, TTM_UPDATETIPTEXTA, 0&, ti
End Property

Public Property Get TipText() As String
    TipText = mvarTipText
End Property

Private Sub Class_Initialize()
    InitCommonControls
    mvarDelayTime = 200
    mvarVisibleTime = 5000
End Sub

Private Sub Class_Terminate()
    Destroy
End Sub

Public Sub Destroy()
    If m_lHwnd <> 0 Then
        DestroyWindow m_lHwnd
        m_lHwnd = 0
    End If
End Sub

Public Property Get VisibleTime() As Long
    VisibleTime = mvarVisibleTime
End Property

Public Property Let VisibleTime(ByVal lData As Long)
    mvarVisibleTime = lData
End Property

Public Property Get DelayTime() As Long
    DelayTime = mvarDelayTime
End Property

Public Property Let DelayTime(ByVal lData As Long)
    mvarDelayTime = lData
End Property


