Attribute VB_Name = "Module1"
Option Explicit

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" ( _
    ByVal hwnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long
Public Const SW_NORMAL As Long = 1

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Type POINTAPI
    x As Long
    y As Long
End Type
Private Declare Function FrameRect Lib "user32.dll" ( _
    ByVal hdc As Long, _
    ByRef lpRect As RECT, _
    ByVal hBrush As Long) As Long
Private Declare Function ScreenToClient Lib "user32.dll" ( _
    ByVal hwnd As Long, _
    ByRef lpPoint As POINTAPI) As Long
Private Declare Function PtInRect Lib "user32.dll" ( _
    ByRef lpRect As RECT, _
    ByVal x As Long, _
    ByVal y As Long) As Long
Private Declare Function GetCursorPos Lib "user32" ( _
    lpPoint As POINTAPI) As Long
Private Declare Function GetWindowRect Lib "user32" ( _
    ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function OleTranslateColor Lib "olepro32.dll" ( _
    ByVal OLE_COLOR As Long, _
    ByVal HPALETTE As Long, _
    pccolorref As Long) As Long

Private Declare Function GetFocus Lib "user32.dll" () As Long

Public Declare Function FindWindowEx Lib "user32.dll" Alias "FindWindowExA" ( _
    ByVal hWnd1 As Long, _
    ByVal hWnd2 As Long, _
    ByVal lpsz1 As String, _
    ByVal lpsz2 As String) As Long

Private Const DI_NORMAL As Long = &H3
Private Declare Function DrawIconEx Lib "user32.dll" ( _
    ByVal hdc As Long, _
    ByVal xLeft As Long, _
    ByVal yTop As Long, _
    ByVal hIcon As Long, _
    ByVal cxWidth As Long, _
    ByVal cyWidth As Long, _
    ByVal istepIfAniCur As Long, _
    ByVal hbrFlickerFreeDraw As Long, _
    ByVal diFlags As Long) As Long

Private Const COLOR_HIGHLIGHT As Long = 13
Private Const COLOR_WINDOW As Long = 5
Private Const COLOR_INACTIVEBORDER As Long = 11

Private Declare Function GetSysColorBrush Lib "user32.dll" ( _
    ByVal nIndex As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" ( _
    ByVal hObject As Long) As Long
Private Declare Function FillRect Lib "user32.dll" ( _
    ByVal hdc As Long, _
    ByRef lpRect As RECT, _
    ByVal hBrush As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    lpvDest As Any, _
    lpvSource As Any, _
    ByVal cbCopy As Long)

Public Declare Function SetWindowLong Lib "user32" Alias _
    "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, _
    ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias _
    "CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
    ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, _
    ByVal lParam As Long) As Long
Public Const GWL_WNDPROC = (-4)

Private Declare Function SelectObject Lib "gdi32" ( _
    ByVal hdc As Long, _
    ByVal hObject As Long) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" ( _
    ByVal hwnd As Long, _
    ByVal wMsg As Long, _
    ByVal wParam As Long, _
    ByRef lParam As Any) As Long

Private Type NMHDR
    hwndFrom As Long
    idfrom As Long
    code As Long
End Type

Private Type NMCUSTOMDRAW
    hdr As NMHDR
    dwDrawStage As Long
    hdc As Long
    rc As RECT
    dwItemSpec As Long ' this is control specific, but it's how to specify an item.  valid only with CDDS_ITEM bit set
    uItemState As Long
    lItemlParam As Long
End Type

Private Type lvItem
    mask As Long
    iItem As Long
    iSubItem As Long
    state As Long
    stateMask As Long
    pszText As String
    cchTextMax As Long
    iImage As Long
    lParam As Long
    iIndent As Long
End Type

Private Type LVHITTESTINFO
    pt As POINTAPI
    flags As Long
    iItem As Long
    iSubItem As Long
End Type

' CustomDraw paint stages.
Private Const CDDS_PREPAINT = &H1
Private Const CDDS_ITEMPREPAINT = (&H10000 Or &H1)
Private Const CDDS_ITEMPOSTPAINT = (&H10000 Or &H2)

' CustomDraw return values.
Private Const CDRF_NOTIFYITEMDRAW = &H20
Private Const CDRF_NOTIFYPOSTPAINT As Long = &H10
Private Const CDRF_DODEFAULT As Long = &H0
Private Const CDRF_NEWFONT As Long = &H2

Private Const CDIS_FOCUS As Long = &H10
Private Const CDIS_SELECTED As Long = &H1

Private Type NMLVCUSTOMDRAW
    nmcd As NMCUSTOMDRAW
    clrText As Long
    clrTextBk As Long
    iSubItem As Long
End Type

Private Const NM_FIRST As Long = 0
Private Const NM_CUSTOMDRAW As Long = (NM_FIRST - 12)
' ***
Private Const WM_NOTIFY As Long = &H4E
Private Const WM_NCACTIVATE As Long = &H86
Private Const WM_MOUSEMOVE As Long = &H200
Private Const WM_NCHITTEST As Long = &H84
Private Const WM_GETFONT As Long = &H31

Private Const LVM_FIRST As Long = &H1000
Private Const LVM_GETITEMRECT As Long = (LVM_FIRST + 14)
Private Const LVM_GETSUBITEMRECT As Long = (LVM_FIRST + 56)
Private Const LVM_GETITEMA As Long = (LVM_FIRST + 5)
Private Const LVM_SUBITEMHITTEST As Long = (LVM_FIRST + 57)
Private Const LVIR_ICON As Long = 1
Private Const LVIR_BOUNDS As Long = 0
Private Const LVIF_IMAGE As Long = &H2

Private Type NMHEADER
    hdr As NMHDR
    iItem As Long
    iButton As Long
    lPtrHDItem As Long
End Type

Private Const HDN_FIRST = -300&
Private Const HDN_DIVIDERDBLCLICK = (HDN_FIRST - 5)
Private Const HDN_BEGINTRACK = (HDN_FIRST - 6)

Private Type HDHITTESTINFO
    pt As POINTAPI
    flags As Long
    iItem As Long
End Type
Private Const HDM_FIRST = &H1200
Private Const HDM_HITTEST = HDM_FIRST + 6
Private Const HDM_GETITEMA = (HDM_FIRST + 3)
Private Const HDM_GETITEM = HDM_GETITEMA

Private Type HD_ITEM
    mask As Long
    cxy As Long
    pszText As String
    hbm As Long
    cchTextMax As Long
    fmt As Long
    lParam As Long
    ' 4.70:
    iImage As Long
    iOrder As Long
End Type
Private Const HDI_LPARAM = &H8

Public TT As CTooltip
Public LVHTT As CTooltip
Public m_lCurHdrItem As Long
Public lvHeaderHwnd As Long
Public mhWndSubClassed As Long
Public mWndProcNext As Long
Public mhWndSubClassed_LV As Long
Public mWndProcNext_LV As Long
Public mhWndSubClassed_LVH As Long
Public mWndProcNext_LVH As Long

Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, _
                           ByVal wParam As Long, ByVal lParam As Long) As Long
    
    Dim tNMH As NMHDR
    Dim pt As POINTAPI, ttRect As RECT
    Dim lvHTI As LVHITTESTINFO, lItemIndex As Long
    
    If uMsg = WM_NOTIFY Then
        
        CopyMemory tNMH, ByVal lParam, Len(tNMH)
        If tNMH.hwndFrom = Form1.ListView1.hwnd And tNMH.code = NM_CUSTOMDRAW Then
'            Debug.Print "NM_CUSTOMDRAW", Rnd
            WindowProc = plCustomDraw(lParam)
            Exit Function
        End If
        
    ElseIf uMsg = WM_NCACTIVATE Then
        ' among other reasons, this message could appear from a mouse click on the tooltip rectangle
        
        If Not TT Is Nothing Then
            If TT.IsShown Then
                GetWindowRect TT.hwnd, ttRect
                GetCursorPos pt
                If PtInRect(ttRect, pt.x, pt.y) <> 0 Then  ' << a bit shorter than using TTM_HITTESTA and TTHITTESTINFO
                    TT.Hide
                    Debug.Print "Tooltip was hidden FORCEDLY", Now
                    
                    ' and convert mouse click to ItemClick event:
                    ScreenToClient Form1.ListView1.hwnd, pt
                    lvHTI.pt.x = pt.x
                    lvHTI.pt.y = pt.y
                    SendMessage Form1.ListView1.hwnd, LVM_SUBITEMHITTEST, 0, lvHTI
                    lItemIndex = lvHTI.iItem + 1
                    If lItemIndex > 0 Then
                        Form1.ListView1.SetFocus
                        Form1.ListView1.ListItems(lItemIndex).Selected = True
                    End If

                    Exit Function  ' << we need to supress this message - otherwise tooltip's
                                   '    parent window (Form1) will remain inactive
                End If
            End If
        End If
        
    ElseIf uMsg = WM_NCHITTEST Or uMsg = WM_MOUSEMOVE Then
        ' the mouse is moving outside the tooltip rectangle:
        
        If TT.IsShown Then
            TT.Hide
            Debug.Print "Tooltip was hidden FORCEDLY", Now
        End If
    End If
    
    WindowProc = CallWindowProc(mWndProcNext, hwnd, uMsg, wParam, ByVal lParam)
    
End Function

Private Function plCustomDraw(ByVal lParam As Long) As Long
    Dim NMLVCD As NMLVCUSTOMDRAW
    Dim lLen As Long
    Dim hFont As Long
    Dim lvRowIndex As Long
    Dim rct As RECT
    Dim hBr As Long, bgColor As Long, bdrColor As Long, tmp As Long
    Dim LVI As lvItem
    
    ' Get the CustomDraw data.
    lLen = Len(NMLVCD)
    
    CopyMemory NMLVCD, ByVal lParam, lLen
    lvRowIndex = NMLVCD.nmcd.dwItemSpec
    
    Select Case NMLVCD.nmcd.dwDrawStage
        
        Case CDDS_PREPAINT
            
            ' Tell it we want to be told when an item is drawn.
            plCustomDraw = CDRF_NOTIFYITEMDRAW
            
        Case CDDS_ITEMPREPAINT
            
            If Not (NMLVCD.nmcd.lItemlParam = 0) Then
                ' listview bug-fix:
                NMLVCD.clrText = TranslateOLEtoRBG(Form1.ListView1.ListItems(lvRowIndex + 1).ForeColor)
                NMLVCD.clrTextBk = TranslateOLEtoRBG(Form1.ListView1.BackColor)
                
                Form1.txtFont.Font.Bold = Form1.ListView1.ListItems(lvRowIndex + 1).Bold
                hFont = SendMessage(Form1.txtFont.hwnd, WM_GETFONT, 0, ByVal 0&)
                SelectObject NMLVCD.nmcd.hdc, hFont
                
                If Form1.chkNoFocus.Value = 1 Then
                    ' removing focus rect:
                    NMLVCD.nmcd.uItemState = NMLVCD.nmcd.uItemState And (Not CDIS_FOCUS)
                End If
                
                If Form1.chkBorderOnly.Value = 1 Then
                    ' removing standard selection:
                    NMLVCD.nmcd.uItemState = NMLVCD.nmcd.uItemState And (Not CDIS_SELECTED)
                End If
                
                CopyMemory ByVal lParam, NMLVCD, lLen
                
            End If
            
            plCustomDraw = CDRF_NOTIFYPOSTPAINT
            
        Case CDDS_ITEMPOSTPAINT
            
            If Form1.chkNiceIcons.Value = 1 Then
                
                ' :::::::::::::::::::::::::: DEALING WITH ITEMS: ::::::::::::::::::::::::::::
                ' (in this sample project items - i.e. the very first column - do have icons)
                
                ' First, we get rect for the icon area of the item:
                rct.Left = LVIR_ICON
                SendMessage NMLVCD.nmcd.hdr.hwndFrom, LVM_GETITEMRECT, lvRowIndex, rct
                
                ' Second, we get icon index for the item:
                LVI.iItem = lvRowIndex
                LVI.iSubItem = 0
                LVI.mask = LVIF_IMAGE
                SendMessage NMLVCD.nmcd.hdr.hwndFrom, LVM_GETITEMA, 0, LVI
                
                ' Third, we draw this icon in the icon area of the item:
                If LVI.iImage >= 0 Then
                    If lvRowIndex + 1 = Form1.ListView1.SelectedItem.Index And Form1.chkBorderOnly.Value = 0 Then
                        If GetFocus() = Form1.ListView1.hwnd Then
                            bgColor = COLOR_HIGHLIGHT
                        Else
                            bgColor = COLOR_INACTIVEBORDER
                        End If
                    Else
                        bgColor = COLOR_WINDOW
                    End If
                    hBr = GetSysColorBrush(bgColor)
                    FillRect NMLVCD.nmcd.hdc, rct, hBr
                    DeleteObject hBr
                    DrawIconEx NMLVCD.nmcd.hdc, _
                       rct.Left, _
                       rct.Top, _
                       Form1.ImageList1.ListImages(LVI.iImage + 1).Picture, _
                       Form1.ImageList1.ImageWidth, _
                       Form1.ImageList1.ImageHeight, _
                       0, _
                       0, _
                       DI_NORMAL
                End If
                
                ' :::::::::::::::::::::::::: DEALING WITH SUBITEMS: ::::::::::::::::::::::::::::
                ' (in this sample project subitems of the 3rd column do have icons)
                
                ' First, we get rect for the icon area of the subitem:
                rct.Left = LVIR_ICON
                rct.Top = 2 ' << points to the 3rd column
                SendMessage NMLVCD.nmcd.hdr.hwndFrom, LVM_GETSUBITEMRECT, lvRowIndex, rct
    
                ' Second, we get icon index for the subitem:
                LVI.iItem = lvRowIndex
                LVI.iSubItem = 2
                LVI.mask = LVIF_IMAGE
                SendMessage NMLVCD.nmcd.hdr.hwndFrom, LVM_GETITEMA, 0, LVI
                
                ' Third, we draw this icon in the icon area of the subitem:
                If LVI.iImage >= 0 Then
                    ' To fill transparent parts of icon with "highlight"-color, we need first to fill icon area with
                    ' this "mask" color and then draw icon with the flag DI_NORMAL ( = DI_IMAGE And DI_MASK):
                    If lvRowIndex + 1 = Form1.ListView1.SelectedItem.Index And Form1.chkBorderOnly.Value = 0 Then
                        If GetFocus() = Form1.ListView1.hwnd Then
                            bgColor = COLOR_HIGHLIGHT
                        Else
                            bgColor = COLOR_INACTIVEBORDER
                        End If
                    Else
                        bgColor = COLOR_WINDOW
                    End If
                    hBr = GetSysColorBrush(bgColor)
                    FillRect NMLVCD.nmcd.hdc, rct, hBr
                    DeleteObject hBr
                    ' Now we draw the icon:
                    DrawIconEx NMLVCD.nmcd.hdc, _
                       rct.Left, _
                       rct.Top, _
                       Form1.ImageList1.ListImages(LVI.iImage + 1).Picture, _
                       Form1.ImageList1.ImageWidth, _
                       Form1.ImageList1.ImageHeight, _
                       0, _
                       0, _
                       DI_NORMAL
                End If
                
            End If
            
            ' ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
            If Form1.chkBorderOnly.Value = 1 Then
                ' replacing color filling with border:
                If lvRowIndex + 1 = Form1.ListView1.SelectedItem.Index Then
                    If GetFocus() = Form1.ListView1.hwnd Then
                        bdrColor = COLOR_HIGHLIGHT
                    Else
                        bdrColor = COLOR_INACTIVEBORDER
                    End If
                    rct.Left = LVIR_ICON
                    SendMessage Form1.ListView1.hwnd, LVM_GETITEMRECT, lvRowIndex, rct
                    tmp = rct.Left
                    rct.Top = Form1.ListView1.ColumnHeaders.Count - 2 ' << "2", ..   -  
                    rct.Left = LVIR_BOUNDS
                    SendMessage Form1.ListView1.hwnd, LVM_GETSUBITEMRECT, lvRowIndex, rct
                    rct.Left = tmp
                    hBr = GetSysColorBrush(bdrColor)
                    FrameRect NMLVCD.nmcd.hdc, rct, hBr
                    DeleteObject hBr
                End If
            End If
            
            plCustomDraw = CDRF_NEWFONT
            
        Case Else
            plCustomDraw = CDRF_DODEFAULT
            
    End Select
    
End Function

Public Function ListView_WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, _
                                    ByVal wParam As Long, ByVal lParam As Long) As Long
    
    Dim tNMH As NMHDR
    Dim tNMHeader As NMHEADER
    
    If uMsg = WM_NOTIFY Then
        Call CopyMemory(tNMH, ByVal lParam, Len(tNMH))
        
        If tNMH.code = HDN_BEGINTRACK Or tNMH.code = HDN_DIVIDERDBLCLICK Then
            ' User began dragging a divider or double clicked the divider area
            Call CopyMemory(tNMHeader, ByVal lParam, Len(tNMHeader))
            
            If (tNMHeader.iItem = 0 Or tNMHeader.iItem = 2) And Form1.chkFixColumns.Value = 1 Then
                ' We prevent tracking (resizing) for the first and third columns of listview:
                ListView_WindowProc = 1
                Exit Function
            ElseIf tNMHeader.iItem = 3 Then
                ' We ALWAYS prevent tracking (resizing) for the fourth column because it's used only for sorting:
                ListView_WindowProc = 1
                Exit Function
            End If
        End If
    End If
    
    'Pass message on to the original window message handler
    ListView_WindowProc = CallWindowProc(mWndProcNext_LV, hwnd, uMsg, wParam, lParam)
    
End Function

Public Function LVHeader_WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, _
                                    ByVal wParam As Long, ByVal lParam As Long) As Long
    
    Dim hti As HDHITTESTINFO
    Dim lCol As Long
    
    If uMsg = WM_MOUSEMOVE And Form1.chkHeaderTips.Value = 1 Then
        ' The low and high words of lParam contains x and y coordinates of the mouse pointer respectively:
        hti.pt.x = LoWord(lParam)
        hti.pt.y = HiWord(lParam)
        ' retrieving the index of the header item under the mouse pointer:
        SendMessage hwnd, HDM_HITTEST, 0&, hti
        ' if the current header changed...
        If hti.iItem <> m_lCurHdrItem Then
            m_lCurHdrItem = hti.iItem
            LVHTT.Destroy
            If m_lCurHdrItem <> -1 Then
                Set LVHTT = New CTooltip
                LVHTT.DelayTime = 300
                LVHTT.VisibleTime = 1000
                LVHTT.Create ParentHwnd:=lvHeaderHwnd, IsTrackable:=False
                LVHTT.Style = TTStandard
                LVHTT.Icon = TTNoIcon
                LVHTT.Title = ""
''                LVHTT.TopLeftCorner = MakeLong(hti.pt.y, hti.pt.x) ' << no sense for non-trackable tooltip
                LVHTT.TipText = Form1.ListView1.ColumnHeaders(m_lCurHdrItem + 1)
''                LVHTT.Show ' << this method is intended ONLY for trackable tooltips!
            End If
        End If
        ' Besides, we can hide in-place listview tooltip here - why not?!
        If TT.IsShown Then
            TT.Hide
            Debug.Print "Tooltip was hidden FORCEDLY", Now
        End If
    End If
    
    LVHeader_WindowProc = CallWindowProc(mWndProcNext_LVH, hwnd, uMsg, wParam, lParam)
    
End Function

Public Function TranslateOLEtoRBG(ByVal dwOleColour As Long) As Long
    ' If the colour is already a valid RGB colour, the function returns the colour without change
    OleTranslateColor dwOleColour, 0, TranslateOLEtoRBG
End Function

Public Function MakeLong(ByVal HiWord As Integer, ByVal LoWord As Integer) As Long
    Call CopyMemory(MakeLong, LoWord, 2)
    Call CopyMemory(ByVal (VarPtr(MakeLong) + 2), HiWord, 2)
End Function

Public Function LoWord(ByVal LongIn As Long) As Integer
    Call CopyMemory(LoWord, LongIn, 2)
End Function

Public Function HiWord(ByVal LongIn As Long) As Integer
    Call CopyMemory(HiWord, ByVal (VarPtr(LongIn) + 2), 2)
End Function


